<?php
/**************************************************
  Coppermine 1.5.x Plugin - Isotope
  *************************************************
  Copyright (c) 2013 Mykee (www.acegem.hu)
  *************************************************
  This plugin based on Isotope gallery script.
  Isotope may be used in commercial projects and applications
  with the one-time purchase of a commercial license. For non-commercial, 
  personal, or open source projects and applications, you may use Isotope 
  under the terms of the MIT License. You may use Isotope for free. If you are 
  paid to do your job, and part of your job is implementing Isotope, 
  a commercial license is required.
  More information here: http://isotope.metafizzy.co/docs/license.html
  ********************************************
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/branches/cpg1.5.x/plugins/isotope/codebase.php $
  $Revision: 6994 $
  $LastChangedBy: mykee $
  $Date: 2013-08-10 23:05:10 +0100 (Sat, 10 Aug 2013) $
  **************************************************/
  
if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}

// Add plugin_install action
$thisplugin->add_action('plugin_install','isotope_install');
// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','isotope_uninstall');
// Add filter for page head
$thisplugin->add_action('page_start','isotope_head');
// Add search display action
$thisplugin->add_filter('plugin_block','isotope_mainpage');
//Add plus styles for metas
$thisplugin->add_filter('page_meta','isotope_header_addons');



// include some stuff in page header
function isotope_head()
{        
    global $ISOTOPESET, $CONFIG, $CPG_PHP_SELF, $JS;
    require ('./plugins/isotope/include/load_isotopeset.php');
    // only insert stuff if we're on album list page
    $isotope_pages_array = array('index.php');
    if (in_array($CPG_PHP_SELF, $isotope_pages_array) == TRUE)
    {
         $JS['includes'][] = "plugins/isotope/js/jquery-1.7.1.min.js";
         $JS['includes'][] = "plugins/isotope/js/jquery.isotope.min.js";
         $JS['includes'][] = "plugins/isotope/js/jquery.tipTip.minified.js";
         
         if($ISOTOPESET['isotope_adipoli'] == 1) {
         $JS['includes'][] = "plugins/isotope/js/jquery.adipoli.min.js";
         }
         
         if($ISOTOPESET['isotope_lbox'] == 1) {
           $JS['includes'][] = "plugins/isotope/lightbox2/jquery.lightbox-0.51.pack.js";
         }
        
    }
}


/* Header style addons */
function isotope_header_addons($html)
{ 
    global $thisplugin, $ISOTOPESET,$CONFIG;
    
    if ($ISOTOPESET['isotope_thumb'] == 1) {
      $width = $CONFIG['thumb_width']."px";
    } else {
      $width = $ISOTOPESET['isotope_width']."px";
    }
    $margin = $ISOTOPESET['isotope_margin'];
    $container = $ISOTOPESET['isotope_container']."px";
    
   $cssblock =  <<< EOT
<!--[if lt IE 9]><script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script><![endif]-->  
<link rel="stylesheet" href="plugins/isotope/css/style.css" type="text/css" media="screen" />
<link rel="stylesheet" href="plugins/isotope/css/tipTip.css" type="text/css" media="screen" />
<link rel="stylesheet" href="plugins/isotope/css/adipoli.css" type="text/css" media="screen" />
<link rel="stylesheet" href="plugins/isotope/css/main.css" type="text/css" media="screen" />
<style type="text/css">
.photos .photo {
   max-width: $width; /* Do not use percent! */
   width: 100%;
   margin: $margin;
}
</style>
EOT;

if ($ISOTOPESET['isotope_container'] != ""){
$cssblock = $cssblock."\n". <<< EOT
<style type="text/css">
.isocentered {
  position:relative;
  margin: 0px auto;
  max-width: $container; 
}
</style>
EOT;
}

if ($ISOTOPESET['isotope_lbox'] == "1"){
$cssblock = $cssblock."\n". <<< EOT
<link rel="stylesheet" href="plugins/isotope/lightbox2/jquery.lightbox-0.5.css" type="text/css" media="screen" />
EOT;
}
    
    return $cssblock.$html;
}


/* String replace */

function stringreplace ($string) {
  
  $string = strtolower(trim($string , "\t\n\r\0\x0B" ));
  $chars = array("á", "é", "ú", "ő", "ó", "ü", "ö", "í", "Á", "É", "Ú", "Ő", "Ó", "Ü", "Ö","Í");
  $charsrep = array("a", "e", "u", "o", "o", "u", "o", "i", "A", "E", "U", "O", "O", "U", "O","I");
  $allowed = "/[^a-z0-9]/i";
  $string = str_replace($chars, $charsrep, $string);
  $string = preg_replace($allowed,"",$string);
  
  return $string;
}



/* Plugin main */
function isotope_mainpage()
{
 global $CONFIG,$lang_plugin_isotope,$FORBIDDEN_SET,$ISOTOPESET,$lang_meta_album_names,$META_ALBUM_SET, $CPG_PHP_SELF,$matches,$html;
 
 // only insert stuff if we're on album list page
    require ('./plugins/isotope/include/init.inc.php');
    require ('./plugins/isotope/include/load_isotopeset.php');
 $isotope_pages_array = array('index.php');
 if (in_array($CPG_PHP_SELF, $isotope_pages_array) == TRUE)
 {
        if($matches[1] != 'isotope') {
          return $matches;
        }
/* Start isotope */    
        echo "\n"."<!-- Isotope Header Start -->"."\n";
        $isotope_icon = array( 'topn' => 'most_viewed', 'lastup' => 'last_uploads', 'toprated' => 'top_rated', 'random' => 'random');
        starttable("100%", cpg_fetch_icon($isotope_icon[$ISOTOPESET['isotope_album']],0,$lang_meta_album_names[$ISOTOPESET['isotope_album']]).$lang_meta_album_names[$ISOTOPESET['isotope_album']]);
endtable();

/* Addon menu for filters */
    $query =  cpg_db_query("SELECT * FROM {$CONFIG['TABLE_ALBUMS']} WHERE visibility = 0");
 //   $i= 0;
    while($isotope_menu = mysql_fetch_array($query)){
      $addonmenu [] = $isotope_menu['title'];
      $addonmenuclass [] = stringreplace ($isotope_menu['title']);
    }

    echo '<div class="isocentered">'."\n".'<h3>'.$lang_plugin_isotope['filter'].'</h3>'."\n".'<ul id="isotope_filter" class="'.$ISOTOPESET['isotope_ulclass'].'">';
    

      for ($i=0; $i<count($addonmenu);$i++){
       echo '<li><a class="isoitem" data-filter=".'.$addonmenuclass[$i].'" href="#">'.$addonmenu[$i].'</a></li>';
    }

    echo '<li><a class="isoitem active" data-filter="*" href="#">'.$lang_plugin_isotope['all'].'</a></li>';
  //  echo '<li><a id="reload" data-filter="*" href="#">'.$lang_plugin_isotope['all'].'</a></li>';
    echo "\n".'</ul>'."\n".'</div>'."\n".'<br clear="all" />';



?>
<!-- Isotope Header End -->
<!-- Isotope Content Start -->
            <div id="isocontainer" class="photos clearfix">
<?php
  // maximum pics to show
  $isotopelimit=$ISOTOPESET['isotope_numberofpics'];
  // request of your database
  $isotope_pics='';
  $isotope_FORBIDDEN_SET = "";
  //if ($FORBIDDEN_SET != "") $isotope_FORBIDDEN_SET = $FORBIDDEN_SET;
  if ($FORBIDDEN_SET != "") $isotope_FORBIDDEN_SET = "$FORBIDDEN_SET";
                                
  // request string for meta album toprated
  if ($ISOTOPESET['isotope_album'] == "toprated") {
    $isotope_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = p.aid WHERE filename like '%.jpg' AND filename not like 'youtube_%' $isotope_FORBIDDEN_SET AND votes >= '{$CONFIG['min_votes_for_rating']}' $META_ALBUM_SET ORDER BY pic_rating DESC, votes DESC, pid DESC LIMIT $isotopelimit";
  }
  // request string for meta album most viewed
  else if ($ISOTOPESET['isotope_album'] == "topn") {
    $isotope_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = p.aid WHERE filename like '%.jpg' AND filename not like 'youtube_%' $isotope_FORBIDDEN_SET AND hits > 0 $META_ALBUM_SET ORDER BY hits DESC, filename LIMIT $isotopelimit";  
  }
  // request string for meta album last uploads
  else if ($ISOTOPESET['isotope_album'] == "lastup") {
    $isotope_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = p.aid WHERE filename like '%.jpg' AND filename not like 'youtube_%' $isotope_FORBIDDEN_SET $META_ALBUM_SET ORDER BY pid DESC LIMIT $isotopelimit";  
  }
  // request string for meta album random pics
  else
  {
  $isotope_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS p LEFT JOIN {$CONFIG['TABLE_ALBUMS']} as a ON  a.aid = p.aid WHERE filename like '%.jpg' AND filename not like 'youtube_%' $isotope_FORBIDDEN_SET $META_ALBUM_SET ORDER BY RAND() LIMIT $isotopelimit";
  }
           
  // For reading result
  $isotope_rowset = array();
  // Index of tab
  $i=0;
  // max height : will be 75px or 100px
  $max_height=0;
  // For each pic.....building javascript in php
  $isotope_minpics = 10;
  
  // result of request
  $isotope_result = cpg_db_query($isotope_query); 
  while($isotope_row = mysql_fetch_array($isotope_result)){
  // reading pid of pic
  $isotope_key=$isotope_row['pid'];
  $album_title= $isotope_row['title'];
  $album_class = stringreplace ($isotope_row['title']);
                //   print_r ($isotope_row); exit;
       
    // path of pic
    $isotope_file=get_pic_url($isotope_row,'thumb');
    $isotope_imgfile=get_pic_url($isotope_row,$ISOTOPESET['isotope_pictype']);
    if ($isotope_imgfile == "images/thumbs/thumb_nopic.png" || $isotope_file == "images/thumbs/thumb_nopic.png") $isotope_imgfile="";
    $isotope_pictitle = $isotope_row['14'];
    // link of pic
    if ($isotope_imgfile !="") {
       if ($ISOTOPESET['isotope_lbox'] == 1) {
            if ($ISOTOPESET['isotope_thumb'] == 1) {
              $isotope_lien="<div class=\"photo $album_class\">"."\n"."<span class=\"tiptip\" title=\"".$isotope_pictitle."<br />".$isotope_row['caption']."\"><a class=\"lightbox\" href=\"".$isotope_imgfile."\" add=\"".$isotope_pictitle."<br />".$isotope_row['caption']."\" ><img class=\"adipoli\" src=\"".$isotope_file."\" border=\"0\" onclick=\"copyspeed=0;\" alt=\"".$isotope_pictitle."\" /></span></a>"."\n"."</div>";    
            } else {
              $isotope_lien="<div class=\"photo $album_class\">"."\n"."<span class=\"tiptip\" title=\"".$isotope_pictitle."<br />".$isotope_row['caption']."\"><a class=\"lightbox\" href=\"".$isotope_imgfile."\" add=\"".$isotope_pictitle."<br />".$isotope_row['caption']."\" ><img class=\"tiptip adipoli\" src=\"".$isotope_imgfile."\" border=\"0\" onclick=\"copyspeed=0;\" alt=\"".$isotope_pictitle."\" /></span></a>"."\n"."</div>";
            }
        } else {
            if ($ISOTOPESET['isotope_thumb'] == 1) {
              $isotope_lien="<div class=\"photo $album_class\">"."\n"."<span class=\"tiptip\" title=\"".$isotope_pictitle."<br />".$isotope_row['caption']."\"><a href=\"displayimage.php?pid=".$isotope_key."\"><img class=\"adipoli\" src=\"".$isotope_file."\" border=\"0\" onclick=\"copyspeed=0;\" alt=\"".$isotope_pictitle."\" /></span></a>"."\n"."</div>";    
            } else {
              $isotope_lien="<div class=\"photo $album_class\">"."\n"."<span class=\"tiptip\" title=\"".$isotope_pictitle."<br />".$isotope_row['caption']."\"><a href=\"displayimage.php?pid=".$isotope_key."\"><img class=\"adipoli\" src=\"".$isotope_imgfile."\" border=\"0\" onclick=\"copyspeed=0;\" alt=\"".$isotope_pictitle."\" /></span></a>"."\n"."</div>";
            }
       
        }

    } else {
    $isotope_lien= "";
    }
    
    // building pictures
    $isotope_pics .= $isotope_lien."\n";
    
    
    $i=$i+1;
   }
    
  // free memory
  mysql_free_result($isotope_result);

?>
                                <?php echo $isotope_pics ?>
</div>                            

<script type="text/javascript">
$(function(){
//Isotope plugin
      var $container = $('#isocontainer');
    
      $container.imagesLoaded( function(){
        $container.isotope({
          itemSelector : '.photo'
        });
      });
      
      $('#isotope_filter a.isoitem').click(function(){
      var selector = $(this).attr('data-filter');
      $container.isotope({ filter: selector });
      $(".active").removeClass("active");
      $(this).addClass("active");
      return false;
        });
        
      $('#reload').click(function(){
          $container.load('index.php #isoloop');
      
      }); 

  <?php if ($ISOTOPESET['isotope_adipoli'] == 1) { ?>   
//Adipoli plugin
      $('.adipoli').adipoli({
          'startEffect' : '<?php echo $ISOTOPESET['isotope_adipoli_start'] ?>',
          'hoverEffect' : '<?php echo $ISOTOPESET['isotope_adipoli_hover'] ?>',
          'imageOpacity': '0.75', // default: 0.5, set value 0 - full transparent to 1 - no transparent with 0.10 steps
          'animSpeed' : '50' //default: 300 - milliseconds
      }); 
  <?php } ?> 
      
//TipTip addons      
      $(".tiptip").tipTip({maxWidth: '400px'});
      
     

   <?php if ($ISOTOPESET['isotope_lbox'] == 1) { ?>   
//Lightbox 0.51 plugin

	// Use this example, or...
//	$('a[@rel*=lightbox]').lightBox(); // Select all links that contains lightbox in the attribute rel
	// This, or...
//	$('#gallery a').lightBox(); // Select all links in object with gallery ID
	// This, or...
	$('a.lightbox').lightBox({
  imageLoading: 'plugins/isotope/lightbox2/images/lightbox-ico-loading.gif',
	imageBtnClose: 'plugins/isotope/lightbox2/images/lightbox-btn-close.gif',
	imageBtnPrev: 'plugins/isotope/lightbox2/images/lightbox-btn-prev.gif',
	imageBtnNext: 'plugins/isotope/lightbox2/images/lightbox-btn-next.gif',
  containerResizeSpeed: 350,
  keyToClose: 'x',
txtImage: 'Kép:',
txtOf: ', Összesen:',
  attribute: 'add'
  }); // Select all links with lightbox class
	// This, or...
//	$('a').lightBox(); // Select all links in the page
	// ... The possibility are many. Use your creative or choose one in the examples above
  <?php } ?> 
  
    });
  
          
</script>

<!-- Isotope Content End -->                        
<?php
echo "\n";
  }
}

// Install
function isotope_install()
{
                global $CONFIG, $thisplugin;
                require 'include/sql_parse.php';

                // create table
                $db_schema = $thisplugin->fullpath . '/schema.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');

                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
                
                // insert default values
                $db_schema = $thisplugin->fullpath . '/basic.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');
              
                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
           return true;
}


// Unnstall and drop settings table
function isotope_uninstall()
{
        global $CONFIG;
        cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}plugin_isotope");
        return true;
}
?>